package org.example.buddy;

import org.example.serviciosweb.HiloWeb;
import org.example.serviciosweb.TipoOperacion;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class AddAmigos extends Activity {

	private EditText edit_anadir_amigo;
	private String amigo, usuario;
	private HiloWeb hiloWeb;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.add_layout);

		edit_anadir_amigo = (EditText) findViewById(R.id.edit_anadir_amigo);
		Button bt_anadir_amigo = (Button) findViewById(R.id.bt_anadir_amigo);

		bt_anadir_amigo.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				addAmigo();
			}
		});

		Bundle extras = getIntent().getExtras();
		usuario = extras.getString("usuario");

	}

	/***
	 * Añáde un amigo a la lista de amigos del usuario.
	 */
	public void addAmigo() {

		Toast toast;
		amigo = edit_anadir_amigo.getText().toString();

		if (amigo.compareTo("") == 0) {
			toast = Toast.makeText(this, "Rellena el campo usuario", 5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		if (amigo.compareTo(usuario) == 0) {
			toast = Toast.makeText(this,
					"No puedes añadirte a tu lista de amigos.", 5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		/**
		 * Inicio la petición para comprobar si el usuario que quiere añadir
		 * como amigo, está dado de alta en el servicio. Luego desde este mismo
		 * hilo, se creará otro para añadir al usuario.
		 */
		hiloWeb = new HiloWeb(this);
		hiloWeb.execute(TipoOperacion.EXISTE_USUARIO_SIN_PASSW, usuario, amigo);

	}
}
