package org.example.buddy;

import java.util.ArrayList;
import java.util.List;

import org.example.serviciosweb.HiloWeb;
import org.example.serviciosweb.HiloWebMostrarAmigos;
import org.example.serviciosweb.TipoOperacion;

import android.app.ListActivity;
import android.os.Bundle;
import android.util.SparseBooleanArray;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;

public class DeleteAmigos extends ListActivity {

	private ListView listView;
	private String usuario;
	private HiloWeb hiloWeb = new HiloWeb(this);
	private HiloWebMostrarAmigos hiloWebMostrarAmigos;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.delete_layout);

		Button bt_delete = (Button) findViewById(R.id.bt_delete);

		bt_delete.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				deleteAmigos();
			}
		});

		Bundle extras = getIntent().getExtras();
		usuario = extras.getString("usuario");

		listView = (ListView) findViewById(android.R.id.list);

		List<String> lista = new ArrayList<String>();
		lista.add(Constantes.MSJ_CARGANDO_LISTA);
		ArrayAdapter<String> listaAmigos = new ArrayAdapter<String>(this,
				android.R.layout.simple_list_item_1, lista);
		listView.setAdapter(listaAmigos);

		/*
		 * Llamamos al servicio mostrar_amigos.php, y el método devuelve los
		 * amigos del usuario en una lista.
		 */
		hiloWebMostrarAmigos = new HiloWebMostrarAmigos(this, listView,
				bt_delete, listaAmigos);

		hiloWebMostrarAmigos.execute(TipoOperacion.MOSTRAR_AMIGOS, usuario);

	}

	public void deleteAmigos() {
		String nombres_amigos_eliminar = "";
		/*
		 * try { wait(6000); } catch (InterruptedException e) { Toast toast =
		 * Toast.makeText(this, "No se pudo recuperar la lista de amigos",
		 * 5000); toast.show(); return; }
		 */

		if (listView.getCount() > 0) {
			SparseBooleanArray checked = listView.getCheckedItemPositions();
			for (int i = 0; i < checked.size(); i++) {
				int pos = checked.keyAt(i);
				if (checked.valueAt(i))
					nombres_amigos_eliminar += "'"
							+ listView.getAdapter().getItem(pos) + "'" + ",";
			}
			nombres_amigos_eliminar = nombres_amigos_eliminar.substring(0,
					nombres_amigos_eliminar.length() - 1);

			hiloWeb = new HiloWeb(this);
			hiloWeb.execute(TipoOperacion.QUITAR_AMIGOS, usuario,
					nombres_amigos_eliminar);
		}

	}
}
