package org.example.buddy;

import org.example.serviciosweb.HiloWeb;
import org.example.serviciosweb.TipoOperacion;

import android.app.Activity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class Registro extends Activity {

	private String nombre = "", passw = "", passw2 = "", correo = "";
	private EditText edit_usuario;
	private EditText edit_passw, edit_passw2, edit_correo;
	private HiloWeb hiloWeb;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.registro_layout);

		edit_usuario = (EditText) findViewById(R.id.edit_reg_usuario);
		edit_passw = (EditText) findViewById(R.id.edit_reg_passw);
		edit_passw2 = (EditText) findViewById(R.id.edit_reg_passw2);
		edit_correo = (EditText) findViewById(R.id.edit_correo);
		Button bt_registro = (Button) findViewById(R.id.bt_reg_registro);

		bt_registro.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				comprobarNombres();
			}
		});

	}

	public void comprobarNombres() {
		nombre = edit_usuario.getText().toString();
		passw = edit_passw.getText().toString();
		passw2 = edit_passw2.getText().toString();
		correo = edit_correo.getText().toString();
		Toast toast;

		if (nombre.length() < 5) {
			toast = Toast
					.makeText(
							this,
							"Fallo de Registro: \nEl nombre de usuario debe tener una longitud de al menos 5 símbolos",
							5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		if (passw.length() < 5) {
			toast = Toast
					.makeText(
							this,
							"Fallo de Registro: \nLa contraseña de usuario debe tener una longitud de al menos 5 símbolos",
							5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		if (correo.equals("")) {
			toast = Toast
					.makeText(
							this,
							"Fallo de Registro: \nDebes de introducir un correo electrónico.",
							5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		if (passw.compareTo(passw2) != 0) {
			toast = Toast
					.makeText(
							this,
							"Fallo de Registro: \nLas contraseñas no son iguales",
							5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		if (passw.compareTo("") == 0 || passw2.compareTo("") == 0) {
			toast = Toast.makeText(this,
					"Fallo de Registro: \nIntroduce las 2 contraseñas", 5000);
			toast.setGravity(Gravity.CENTER, 5, 5);
			toast.show();
			return;
		}

		hiloWeb = new HiloWeb(this);
		hiloWeb.execute(TipoOperacion.REGISTRA_USUARIO, nombre, passw, correo);

	}
}
