package org.example.serviciosweb;

import org.example.buddy.Constantes;
import org.example.buddy.Home;

import android.app.Activity;
import android.os.AsyncTask;
import android.util.Log;
import android.view.Gravity;
import android.widget.Toast;

public class HiloWeb extends AsyncTask<Object, Integer, String> {

	private Activity actividad;
	private TipoOperacion OPERACION;
	private String usuario;
	private String nombres_amigos_eliminar;
	private String estado;
	private double latitud;
	private double longitud;
	private String amigo;
	private String correo;
	private String cuerpo;
	private String mensaje;
	private Toast toast;

	public HiloWeb(Activity actividad) {
		this.actividad = actividad;

	}

	@Override
	protected String doInBackground(Object... arg) {

		OPERACION = (TipoOperacion) arg[0];
		usuario = (String) arg[1];

		if (OPERACION == TipoOperacion.EXISTE_USUARIO_SIN_PASSW) {
			amigo = (String) arg[2];
			return ServicioWebUsuarios.existeUsuario(amigo);
		} else if (OPERACION == TipoOperacion.ADD_AMIGO) {
			amigo = (String) arg[2];
			return ServicioWebUsuarios.addAmigo(usuario, amigo);
		} else if (OPERACION == TipoOperacion.QUITAR_AMIGOS) {
			nombres_amigos_eliminar = (String) arg[2];
			return ServicioWebUsuarios.quitarAmigos(usuario,
					nombres_amigos_eliminar);
		} else if (OPERACION == TipoOperacion.REGISTRA_USUARIO) {
			String passw = (String) arg[2];
			String correo = (String) arg[3];
			return ServicioWebUsuarios.registraUsuario(usuario, passw, correo);
		} else if (OPERACION == TipoOperacion.ACTUALIZAR_ESTADO) {
			estado = (String) arg[2];
			latitud = (Double) arg[3];
			longitud = (Double) arg[4];
			return ServicioWebUsuarios.escribirEstado(usuario, estado, latitud,
					longitud);
		} else if (OPERACION == TipoOperacion.ESCRIBIR_MENSAJE) {
			amigo = (String) arg[2];
			mensaje = (String) arg[3];
			return ServicioWebUsuarios.escribirMensaje(usuario, amigo, mensaje);
		} else if (OPERACION == TipoOperacion.MARCAR_LEIDOS) {
			return ServicioWebUsuarios.marcarLeidos(usuario);
		}

		else {
			String asunto = usuario;
			correo = (String) arg[2];
			cuerpo = (String) arg[3];
			return ServicioWebUsuarios.enviarCorreo(asunto, correo, cuerpo);
		}

	}

	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);

		if (result == null) {
			result = "";
		}

		try {

			/*
			 * Si registramos un nuevo usuario.
			 */
			if (OPERACION == TipoOperacion.REGISTRA_USUARIO) {
				// Si no existe el usuario, lo registra en la base de datos
				// remota
				if (result.equals("OK")) {

					toast = Toast.makeText(actividad, "Registro de usuario "
							+ usuario
							+ " con éxito.\nInicie sesión con dicho usuario",
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
					actividad.finish();
				} else if (result.equals("KO")) {
					toast = Toast.makeText(actividad,
							"Fallo de Registro: \nEl usuario ya existe",
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

				// Si existe, el usuario no podrá ser creado
				else {
					toast = Toast
							.makeText(actividad, result, Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

			}

			else if (OPERACION == TipoOperacion.QUITAR_AMIGOS) {
				if (result.equals("OK")) {
					toast = Toast.makeText(actividad,
							"Usuarios " + nombres_amigos_eliminar
									+ " eliminados con éxito",
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
					actividad.setResult(Activity.RESULT_OK);
					actividad.finish();
				} else {
					toast = Toast
							.makeText(
									actividad,
									"Fallo del sistema.\n"
											+ "No se pudo realizar la operación de quitar amigos.",
									Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

			}

			/*
			 * Si la operación es preguntar si un amigo existe en la aplicación.
			 */
			else if (OPERACION == TipoOperacion.EXISTE_USUARIO_SIN_PASSW) {

				// Si no existe el amigo como usuario de la aplicación.
				if (!result.equals("OK")) {
					if (result.equals("KO")) {
						toast = Toast.makeText(actividad,
								"El usuario no existe", Toast.LENGTH_LONG);
						toast.setGravity(Gravity.CENTER, 5, 5);
						toast.show();
					} else {
						toast = Toast.makeText(actividad, result,
								Toast.LENGTH_LONG);
						toast.setGravity(Gravity.CENTER, 5, 5);
						toast.show();
					}

				}
				// Si existe ..
				else {

					/**
					 * Inicia una petición en un nuevo hilo para añadir al amigo
					 * a la lista.
					 */
					HiloWeb hiloWeb = new HiloWeb(actividad);
					hiloWeb.execute(TipoOperacion.ADD_AMIGO, usuario, amigo);

				}

			}

			/*
			 * Será llamado para añadir un amigo a la lista del usuario. Se
			 * llamará desde el propio hilo después de una llamada para
			 * comprobar si un amigo es usuario de la
			 * aplicación(TipoOperacion.EXISTE_USUARIO_SIN_PASSW.
			 */
			else if (OPERACION == TipoOperacion.ADD_AMIGO) {

				if (!result.equals("")) {
					// Si pudo añadirlo a la lista...
					if (result.equals("OK")) {
						toast = Toast.makeText(actividad, "Tu amigo " + amigo
								+ " ha sido añadido", Toast.LENGTH_LONG);
						toast.setGravity(Gravity.CENTER, 5, 5);
						toast.show();
						actividad.setResult(Activity.RESULT_OK);
						actividad.finish();
						// Sino, puede ser que no tenga acceso a internet
					} else if (result.equals("No tienes acceso a internet.")) {
						toast = Toast
								.makeText(
										actividad,
										"No tienes acceso a internet. Activa Wifi o tarifa de datos.",
										Toast.LENGTH_LONG);
						toast.setGravity(Gravity.CENTER, 5, 5);
						toast.show();
					}

					// o que el usuario ya estuba en dicha lista.
					else {
						toast = Toast.makeText(actividad, "Tu amigo " + amigo
								+ " ya estaba en tu lista de amigos",
								Toast.LENGTH_LONG);
						toast.setGravity(Gravity.CENTER, 5, 5);
						toast.show();
					}

				}

			}

			/*
			 * Si la operación es mandar un correo de invitación a la
			 * aplicación.
			 */
			else if (OPERACION == TipoOperacion.ENVIAR_CORREO) {
				if (result.equals("OK")) {
					toast = Toast.makeText(actividad,
							"Correo electrónico enviado con éxito a " + correo,
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();

					if (actividad.getClass() != Home.class) {
						actividad.finish();
					}

				} else if (result.equals("KO")) {
					toast = Toast.makeText(actividad,
							"Error enviando correo electrónico",
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

				else {
					toast = Toast
							.makeText(actividad, result, Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

			}

			/*
			 * Si es para actualizar el estado, es decir
			 * estado=conectado/desconectado y localización del usuario.
			 */
			else if (OPERACION == TipoOperacion.ACTUALIZAR_ESTADO) {

				if (result.equals("OK")) {

					HiloWebMostrarLocalizacion hiloWeb = new HiloWebMostrarLocalizacion(
							actividad, null, null);
					hiloWeb.execute(usuario, null);

				}

			} else if (OPERACION == TipoOperacion.MARCAR_LEIDOS) {

				if (result.equals("OK")) {
					Log.d("Buddy", "Mensajes de " + usuario
							+ " marcados como leídos");
				}

				else if (result.equals("KO")) {
					toast = Toast.makeText(actividad,
							"Error actualizando los mensajes como leídos",
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

				else {
					toast = Toast.makeText(actividad,
							"Error actualizando los mensajes como leídos.\n\n"
									+ result, Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}
			}

			else {

				if (result.equals("OK")) {
					toast = Toast.makeText(actividad,
							"Mensaje enviado correctamente a amigo  " + amigo,
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();

				} else if (result.equals("KO")) {
					toast = Toast.makeText(actividad,
							"Error escribiendo mensaje a " + amigo,
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

				else {
					toast = Toast
							.makeText(actividad, result, Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

			}

		} catch (Exception e) {
			Log.e("Buddy_manual", Constantes.MSJ_ERROR_HILOS);
		}

	}
}
