package org.example.serviciosweb;

import org.example.buddy.Constantes;
import org.example.buddy.Home;
import org.example.buddy.R;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.util.Log;
import android.view.Gravity;
import android.widget.CheckBox;
import android.widget.Toast;

public class HiloWebIngreso extends AsyncTask<String, Void, String> {

	private ProgressDialog progreso;
	private Activity actividad;
	private String usuario;
	private String passw;

	public HiloWebIngreso(Activity actividad, ProgressDialog progreso) {
		this.actividad = actividad;
		this.progreso = progreso;
	}

	@Override
	protected void onPreExecute() {
		super.onPreExecute();
		try {

			progreso.show();
			progreso.setOnCancelListener(new OnCancelListener() {

				@Override
				public void onCancel(DialogInterface dialog) {
					cancel(true);

				}
			});

		} catch (Exception e) {
			Log.e("Buddy_manual", Constantes.MSJ_ERROR_HILOS);
		}

	}

	@Override
	protected String doInBackground(String... arg) {

		usuario = (String) arg[0];
		passw = (String) arg[1];
		if (!isCancelled()) {
			return ServicioWebUsuarios.existeUsuario(usuario, passw);
		}
		return null;
	}

	@Override
	protected void onCancelled() {
	}

	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);

		try {

			if (result != null) {

				if (result.equals("OK")) {
					Intent intent = new Intent(actividad, Home.class);
					intent.putExtra("usuario", usuario);
					CheckBox check_credenciales = (CheckBox) actividad
							.findViewById(R.id.check_credenciales);
					if (check_credenciales.isChecked()) {
						SharedPreferences preferencias = actividad
								.getSharedPreferences(Constantes.PREFERENCIAS,
										Context.MODE_PRIVATE);
						SharedPreferences.Editor editor = preferencias.edit();
						editor.putString("usuario", usuario);
						editor.putString("passw", passw);
						editor.commit();
					}

					// Iniciamos el servicio para mensajería
					Intent i = new Intent(actividad, ServicioMensajeria.class);
					i.putExtra("usuario", usuario);
					actividad.startService(i);

					i = new Intent(actividad, ServicioActualizacionListas.class);
					actividad.startService(i);

					actividad.startActivity(intent);
					actividad.finish();

				} else if (result.equals("KO")) {
					Toast toast = Toast
							.makeText(actividad,
									"Usuario o contraseña erróneos.",
									Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				} else {
					Toast toast = Toast.makeText(actividad, result,
							Toast.LENGTH_LONG);
					toast.setGravity(Gravity.CENTER, 5, 5);
					toast.show();
				}

			}

			progreso.dismiss();

		} catch (Exception e) {
			Log.e("Buddy_manual", Constantes.MSJ_ERROR_HILOS);
			Log.e("Buddy", e.getMessage());

		}
	}
}
