package org.example.serviciosweb;

import java.util.ArrayList;
import java.util.List;

import org.example.buddy.Constantes;
import org.example.buddy.R;

import android.app.Activity;
import android.app.ListActivity;
import android.os.AsyncTask;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class HiloWebMostrarAmigos extends AsyncTask<Object, Void, List<String>> {

	private Activity actividad;
	private TipoOperacion OPERACION;
	private ListView listView;
	private Button bt_delete;
	private ArrayAdapter<String> listaAmigos;

	public HiloWebMostrarAmigos(ListActivity actividad, ListView listView,
			Button bt_delete, ArrayAdapter<String> listaAmigos) {
		this.actividad = actividad;
		this.listaAmigos = listaAmigos;
		this.listView = listView;
		this.bt_delete = bt_delete;

	}

	public HiloWebMostrarAmigos(Activity actividad, ListView listView) {
		this.actividad = actividad;
		this.listView = listView;

	}

	@Override
	protected void onPreExecute() {
		super.onPreExecute();

		try {

		} catch (Exception e) {
			Log.e("Buddy_manual",
					"Error entre los los hilos secundarios y el principal.");
		}
	}

	@Override
	protected List<String> doInBackground(Object... arg) {

		OPERACION = (TipoOperacion) arg[0];
		String usuario = (String) arg[1];

		if (OPERACION == TipoOperacion.MOSTRAR_AMIGOS) {
			return ServicioWebUsuarios.mostrarAmigos(usuario);
		} else {
			String estado = (String) arg[2];
			return ServicioWebUsuarios.mostrarAmigos(usuario, estado);
		}

	}

	@Override
	protected void onPostExecute(List<String> result) {
		super.onPostExecute(result);

		try {

			/*
			 * Si la tarea mostrar todos los amigos del usuario.
			 */
			if (OPERACION == TipoOperacion.MOSTRAR_AMIGOS) {

				if (result == null) {

					/*
					 * Hacemos invisibles la lista y el botón si no hay amigos
					 * en la lista
					 */
					listView.setVisibility(View.GONE);
					bt_delete.setVisibility(View.GONE);
					// Y creamos un TextView indicándolo
					TextView text_no_amigos = new TextView(actividad);
					text_no_amigos.setText(Constantes.MSJ_LISTA_FALLO);
					text_no_amigos.setGravity(Gravity.CENTER);
					LinearLayout Layout_lista_amigos = (LinearLayout) actividad
							.findViewById(R.id.Layout_lista_amigos);
					Layout_lista_amigos.addView(text_no_amigos);

				} else {

					if (result.size() == 0) {
						/*
						 * Hacemos invisibles la lista y el botón si no hay
						 * amigos en la lista
						 */
						listView.setVisibility(View.GONE);
						bt_delete.setVisibility(View.GONE);
						// Y creamos un TextView indicándolo
						TextView text_no_amigos = new TextView(actividad);
						text_no_amigos.setText(Constantes.MSJ_LISTA_NO_USER);
						text_no_amigos.setGravity(Gravity.CENTER);
						LinearLayout Layout_lista_amigos = (LinearLayout) actividad
								.findViewById(R.id.Layout_lista_amigos);
						Layout_lista_amigos.addView(text_no_amigos);
					} else {
						/*
						 * Creamos el adaptador a partir del diseño de android
						 * de una lista de elementos tipo checking.
						 */
						listaAmigos = new ArrayAdapter<String>(
								actividad,
								android.R.layout.simple_list_item_multiple_choice,
								result);
						listView.setAdapter(listaAmigos);
					}
				}

				/*
				 * Si solo se mostrarán los amigos conectados o desconectados.
				 */
			} else {

				if (result == null) {

					result = new ArrayList<String>();
					result.add(Constantes.MSJ_LISTA_FALLO);

				} else {

					if (result.size() == 0) {
						result.add(Constantes.MSJ_LISTA_NO_USER);
					}

				}
				listaAmigos = new ArrayAdapter<String>(actividad,
						android.R.layout.simple_list_item_1, result);
				listView.setAdapter(listaAmigos);

			}

		} catch (Exception e) {
			Log.e("Buddy_manual", Constantes.MSJ_ERROR_HILOS);
		}
	}

}
