package org.example.serviciosweb;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.List;

import android.util.Log;

public class ServicioWebUsuarios {

	// private static final String HOSTING =
	// "http://android-upv.esy.es/usuarios_Buddy/";
	// private static final String HOSTING =
	// "http://buddyandroid.net16.net/usuarios_Buddy/";
	// private static final String HOSTING = "http://79.109.158.149/";
	private static String HOSTING;// = "http://192.168.1.171/";

	public static void setHosting(String hosting) {
		HOSTING = hosting;
	}

	/***
	 * Comprueba si existe el usuario para el ingreso en la aplicación.
	 * 
	 * @param nombre
	 * @param passw
	 * @return
	 */
	public static String existeUsuario(String nombre, String passw) {

		if (nombre == null || passw == null) {
			return "KO";
		}

		byte[] passB = passw.getBytes();

		try {
			MessageDigest messageD = MessageDigest.getInstance("SHA-1");
			messageD.update(passB);
			byte[] bytes = messageD.digest();

			StringBuilder passS = new StringBuilder(); // Para usar una String
														// mutable

			for (byte b : bytes) { // Convertimos a hex
				passS.append(String.format("%02x", b));
			}

			passw = passS.toString();

		} catch (NoSuchAlgorithmException e1) {
			e1.printStackTrace();
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "comprobar_usuario.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("nombre=");

			sal.write(URLEncoder.encode(nombre, "UTF-8"));

			sal.write("&passw=");

			sal.write(URLEncoder.encode(passw, "UTF-8"));

			sal.flush();

			conexion.setReadTimeout(1000);

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";

				}

				reader.close();
				conexion.disconnect();
			} else {

				Log.e("Buddy", "Error en servicio Web comprobarUsuario");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";

			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";

		}

		return "KO";

	}

	public static String existeUsuario(String nombre) {

		if (nombre == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "comprobar_usuario_sin_passw.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("nombre=");

			sal.write(URLEncoder.encode(nombre, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && nombre.compareTo(linea) == 0) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web exite_usuario");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	/***
	 * Registra un nuevo usuario.
	 * 
	 * @param nombre
	 * @param passw
	 * @return
	 */
	public static String registraUsuario(String nombre, String passw,
			String correo) {

		if (nombre == null || passw == null) {
			return "KO";
		}

		byte[] passB = passw.getBytes();

		try {
			MessageDigest messageD = MessageDigest.getInstance("SHA-1");
			messageD.update(passB);
			byte[] bytes = messageD.digest();

			StringBuilder passS = new StringBuilder(); // Para usar una String
														// mutable

			for (byte b : bytes) { // Convertimos a hex
				passS.append(String.format("%02x", b));
			}

			passw = passS.toString();

		} catch (NoSuchAlgorithmException e1) {
			e1.printStackTrace();
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "registrar_usuario.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("nombre=");

			sal.write(URLEncoder.encode(nombre, "UTF-8"));

			sal.write("&passw=");

			sal.write(URLEncoder.encode(passw, "UTF-8"));

			sal.write("&correo=");

			sal.write(URLEncoder.encode(correo, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web comprobarUsuario");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	public static String addAmigo(String usuario, String amigo) {

		if (usuario == null || amigo == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "add_amigo.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.write("&amigo=");

			sal.write(URLEncoder.encode(amigo, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web comprobarUsuario");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	/***
	 * Método que devuelve los nombres de los amigos del usuario
	 * 
	 * @param usuario
	 * @param amigo
	 * @return
	 */
	public static List<String> mostrarAmigos(String usuario) {

		if (usuario == null) {
			return null;
		}

		List<String> lista_amigos = new ArrayList<String>();

		try {

			URL url = new URL(HOSTING + "mostrar_amigos.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null) {

					if (linea.equals("KO")) {
						reader.close();
						conexion.disconnect();
						return lista_amigos;
					}
					while (linea != null && !linea.equals("")) {
						lista_amigos.add(linea);
						if (reader != null)
							linea = reader.readLine();
					}

					return lista_amigos;

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta mostrando amigos");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para mostrar amigos");
			Log.e("Buddy", e.getMessage(), e);
			return null;

		}

		return null;

	}

	/***
	 * Método que devuelve los nombres de los amigos del usuario
	 * 
	 * @param usuario
	 * @param amigo
	 * @return
	 */
	public static List<String> mostrarAmigos(String usuario, String estado) {

		List<String> lista_amigos = new ArrayList<String>();

		if (usuario == null) {
			return null;
		}

		lista_amigos = mostrarAmigos(usuario);
		
		if (lista_amigos == null) {
			return null;
		}

		try {

			URL url = new URL(HOSTING + "mostrar_amigos_estado.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("estado=");

			sal.write(URLEncoder.encode(estado, "UTF-8"));

			sal.write("&amigos=");

			String amigos = lista_amigos.toString();

			/*
			 * Quitamos los [] que devuelve la función toSTring() de lista, y
			 * reemplazamos los espacios entre usuarios que introduce también
			 * dicha función.
			 */
			amigos = amigos.substring(1, amigos.length() - 1);
			amigos = amigos.replace(" ", "");

			sal.write(URLEncoder.encode(amigos, "UTF-8"));

			sal.flush();

			lista_amigos = new ArrayList<String>();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null) {

					if (linea.equals("KO")) {
						reader.close();
						conexion.disconnect();
						return lista_amigos;
					}
					while (linea != null && !linea.equals("")) {
						lista_amigos.add(linea);
						if (reader != null)
							linea = reader.readLine();
					}

					return lista_amigos;

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta mostrando amigos");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para mostrar amigos");
			Log.e("Buddy", e.getMessage(), e);
			return null;

		}

		// Si fallo por otra razón...
		return null;

	}

	/***
	 * Método para quitar los usuarios en la base de datos a través del sercicio
	 * web quitar_amigos.php
	 * 
	 * @param usuario
	 * @return
	 */
	public static String quitarAmigos(String usuario, String nombre_amigos) {

		if (usuario == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "quitar_amigos.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.write("&amigos=");

			sal.write(URLEncoder.encode(nombre_amigos, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web comprobarUsuario");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	public static String enviarCorreo(String asunto, String correo,
			String cuerpo) {

		if (correo == null || cuerpo == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "enviar_correo.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("asunto=");

			sal.write(URLEncoder.encode(asunto, "UTF-8"));

			sal.write("&correo=");

			sal.write(URLEncoder.encode(correo, "UTF-8"));

			sal.write("&cuerpo=");

			sal.write(URLEncoder.encode(cuerpo, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web enviar_correo");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	/**
	 * Método que actualiza el estado y localización del usuario que ha iniciado
	 * sesión.
	 * 
	 * @param nombre
	 * @return
	 */
	public static String escribirEstado(String usuario, String estado,
			double latitud, double longitud) {

		if (usuario == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "escribir_estado.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.write("&estado=");

			sal.write(URLEncoder.encode(estado, "UTF-8"));

			sal.write("&latitud=");

			String lat = String.valueOf(latitud);

			sal.write(URLEncoder.encode(lat, "UTF-8"));

			sal.write("&longitud=");

			String longi = String.valueOf(longitud);

			sal.write(URLEncoder.encode(longi, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy", "Error en servicio Web escribir_estado");
				Log.e("Buddy", conexion.getResponseMessage());
				return "La página solicitada no está accesible.";
			}

		} catch (Exception e) {

			Log.e("Buddy Manual", "Error de conexión");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";
		}

		return "KO";

	}

	/***
	 * Muestra la localización del usuario o de los amigos.
	 * 
	 * @param usuario
	 * @return
	 */
	public static List<Double> mostrarLocalizacion(String usuario) {

		List<Double> lista_localizacion = new ArrayList<Double>();

		if (usuario == null) {
			return lista_localizacion;
		}

		try {

			URL url = new URL(HOSTING + "mostrar_localizacion.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null) {

					if (linea.equals("KO")) {
						reader.close();
						conexion.disconnect();
						return lista_localizacion;
					}
					if (linea != null && !linea.equals("")) {

						lista_localizacion.add(Double.valueOf(linea));
						linea = reader.readLine();
						lista_localizacion.add(Double.valueOf(linea));
					}

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta mostrando amigos");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para mostrar amigos");
			Log.e("Buddy", e.getMessage(), e);

		}

		return lista_localizacion;

	}

	/***
	 * Mostrará los mensajes no leídos del usuario.
	 * 
	 * @param usuario
	 * @return
	 */
	public static List<String> mostrarMensajes(String usuario) {

		List<String> lista_mensajes = new ArrayList<String>();

		if (usuario == null) {
			return null;
		}

		try {

			URL url = new URL(HOSTING + "mostrar_mensajes.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null) {

					if (linea.equals("KO")) {
						reader.close();
						conexion.disconnect();
						return lista_mensajes;
					}
					while (linea != null && !linea.equals("")) {
						lista_mensajes.add(linea);
						linea = reader.readLine();
					}

				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta mostrando amigos");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para mostrar amigos");
			Log.e("Buddy", e.getMessage(), e);

		}

		return lista_mensajes;

	}

	/**
	 * Escribe un mensaje en la tabla del usuario.
	 * 
	 * @param usuario
	 * @return
	 */
	public static String escribirMensaje(String usuario, String amigo,
			String mensaje) {

		if (usuario == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "escribir_mensaje.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.write("&amigo=");

			sal.write(URLEncoder.encode(amigo, "UTF-8"));

			sal.write("&mensaje=");

			sal.write(URLEncoder.encode(mensaje, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta escribiendo mensajes");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para escribir mensajes");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";

		}

		return "KO";

	}

	/**
	 * Marca los mensajes del usuario como leídos.
	 * 
	 * @param usuario
	 * @return
	 */
	public static String marcarLeidos(String usuario) {

		if (usuario == null) {
			return "KO";
		}

		try {

			URL url = new URL(HOSTING + "marcar_leidos.php");

			HttpURLConnection conexion = (HttpURLConnection) url

			.openConnection();

			conexion.setRequestMethod("POST");

			conexion.setDoOutput(true);

			OutputStreamWriter sal = new OutputStreamWriter(
					conexion.getOutputStream());

			sal.write("usuario=");

			sal.write(URLEncoder.encode(usuario, "UTF-8"));

			sal.flush();

			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK) {

				BufferedReader reader = new BufferedReader(
						new InputStreamReader(conexion.getInputStream()));

				String linea = reader.readLine();

				if (linea != null && linea.equals("OK")) {
					reader.close();
					conexion.disconnect();
					return "OK";
				}

				reader.close();
				conexion.disconnect();

			} else {

				Log.e("Buddy_manual",
						"Error, respuesta incorrecta escribiendo mensajes");
				Log.e("Buddy", conexion.getResponseMessage());

			}

		} catch (Exception e) {

			Log.e("Buddy_manual",
					"Error conectando con servicio para escribir mensajes");
			Log.e("Buddy", e.getMessage(), e);
			return "Error de conexión.";

		}

		return "KO";

	}

}
